<?php
    $groups = [];
    if ($this->module()->isActive('keyword')) {
        $groups = $this->allowedKeywordGroups('task', false);
    }
?>

<div ng-controller="taskListController as self" ng-init="self.init(<?= $this->authStorage()->getUser()->getId() ?>, '<?= $this->from ?>', <?= $this->object ? $this->object->getId() : 'null' ?>)">
    <div class="row">
        <div class="col-xs-12">
            <table-builder options="self.options" items="self.tasks" class="table-builder">
                <div class="row">
                    <div class="col-sm-4">
                        <div class="table-filters little-panel">
                            <div class="title" data-toggle="collapse" href="#filters-collapsed-task">
                                <?= $this->icon('filters', 'fa-fw') ?>
                                <?= $this->translate('filters') ?>
                            </div>

                            <div id="filters-collapsed-task" class="body collapse">
                                <?= $this->tableFilter('__tb.apiParams.search.data.filters', $this->taskFilters(['project'])); ?>
                                <div class="row">
                                    <div class="col-xs-6">
                                        <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                    </div>
                                    <div class="col-xs-6 text-right">
                                        <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                            <?= $this->translate('table_filter_button') ?>
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <table-builder-columns></table-builder-columns>
                    </div>

                    <div class="col-sm-4">
                        <div class="btn-group pull-right">
                            <button class="btn btn-lg" ng-click="__tb.removeFromList()" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                                <?= $this->icon('eraser', 'fa-fw pointer') ?>
                            </button>
                            <button class="btn btn-lg btn-excel" type="button" ng-click="__tb.exportExcel()" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                                <?= $this->icon('excel', 'fa-fw pointer') ?>
                            </button>
                        </div>
                        <div class="btn-group pull-right">
                            <?php if ($this->acl()->isAllowed('task:e:task:c')) : ?>
                                <button type="button" class="btn btn-lg" ng-click="self.createTask()" <?= ($this->acl()->onlyOwned('project:e:project:u') ? 'ng-if="self.isMember(' . $this->authStorage()->getUser()->getId() . ')"' : '') ?>>
                                    <?= $this->icon('create') ?>
                                    <?= $this->translate('task_nav_form'); ?>
                                </button>
                            <?php endif; ?>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xs-12">
                        <form name="taskForm">
                            <table table-builder-table class="table table-bordered table-condensed table-hover">
                                <thead>
                                    <tr>
                                        <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                        <th tb-column tb-name="name"    tb-sortable="true" tb-toggle="true"><?= $this->translate('task_field_name') ?></th>
                                        <th tb-column tb-name="users.name" tb-sortable="false" tb-toggle="true"><?= $this->translate('task_field_users') ?></th>
                                        <th tb-column tb-name="start"  tb-sortable="true" tb-toggle="true"><?= $this->translate('task_field_start') ?></th>
                                        <th tb-column tb-name="end"    tb-sortable="true" tb-toggle="true"><?= $this->translate('task_field_end') ?></th>
                                        <th tb-column tb-name="progress"  tb-sortable="true" tb-toggle="true"><?= $this->translate('task_field_progress') ?></th>
                                        <?php
                                        if ($this->module()->isActive('keyword')) {
                                            foreach ($groups as $group) {
                                                echo '<th tb-column tb-name="keyword' . $group->getId() . '" tb-sortable="false" tb-toggle="true">' . $group->getName() . '</th>';
                                            }
                                        }
                                        ?>
                                        <th tb-column tb-name="createdAt"  tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('task_field_createdAt') ?></th>
                                        <th tb-column tb-name="updatedAt"  tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('task_field_updatedAt') ?></th>
                                        <th tb-column tb-name="actions" class="actions-column"></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr ng-repeat="task in self.tasks">
                                        <td><input type="checkbox" ng-model="task.selected"/></td>
                                        <td class="editable">
                                            <span ng-show="self.editedLine !== task">
                                                <a ng-if="task._rights.read" ng-click="self.editTask(task)" class="pointer">{{task.name}}</a>
                                                <span ng-if="!task._rights.read">{{task.name}}</span>

                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(task)', 'ng-if' => 'task._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == task">
                                                <input type="text" name="name" class="form-control" required autocomplete="off"
                                                       ng-model="self.editedLineFields.name"  />
                                                <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <td class="editable">
                                            <span ng-show="self.editedLine !== task"  class="comma-separated">
                                                <span ng-repeat="user in task.users"><!--
                                                <?php if ($this->acl()->isAllowed('user:e:user:r')) : ?>
                                                    --><a href="<?= $this->url('user/form') ?>/{{user.id}}">{{user.name}}</a><!--
                                                <?php else : ?>
                                                    -->{{user.name}}<!--
                                                <?php endif; ?>
                                                --></span>
                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(task)', 'ng-if' => 'task._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == task">
                                                <user-select name="users" ng-model="self.editedLineFields.users"
                                                                required="true" multiple="true" form="taskForm"></user-select>
                                                <field-errors field="users" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <td class="editable">
                                            <span ng-show="self.editedLine !== task">
                                                {{task.start | dateFormat : 'DD/MM/YYYY'}}
                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(task)', 'ng-if' => 'task._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == task">
                                                <input type="text" name="start" class="form-control" required autocomplete="off" input-mask="qdate"
                                                       ng-model="self.editedLineFields.start" />
                                                <field-errors field="start" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <td class="editable">
                                            <span ng-show="self.editedLine !== task">
                                                {{task.end | dateFormat : 'DD/MM/YYYY'}}
                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(task)', 'ng-if' => 'task._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == task">
                                                <input type="text" name="end" class="form-control" required autocomplete="off" input-mask="qdate"
                                                       ng-model="self.editedLineFields.end" />
                                                <field-errors field="end" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <td class="editable text-right">
                                            <span ng-show="self.editedLine !== task">
                                                <div class="progress">
                                                    <div class="progress-bar"  ng-style="{width: task.progress + '%'}">
                                                        {{task.progress}} %
                                                    </div>
                                                </div>
                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(task)', 'ng-if' => 'task._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == task">
                                                <input type="text" name="progress" class="form-control" required autocomplete="off" input-mask="integer"
                                                       ng-model="self.editedLineFields.progress" />
                                                <field-errors field="progress" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <?php
                                            if ($this->module()->isActive('keyword')) {
                                                foreach ($groups as $group) {
                                                    echo '<td class="editable">';
                                                        echo '<span class="comma-separated" ng-show="self.editedLine !== task">';
                                                            echo '<span ng-repeat="keyword in task.keywords[' . $group->getId() . ']">{{keyword.name}}</span>';
                                                            echo $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(task)', 'ng-if' => 'task._rights.update']);
                                                        echo '</span>';
                                                        echo '<span ng-if="self.editedLine == task">';
                                                            echo '<keyword-select ng-model="self.editedLineFields.keywords[' . $group->getId() . ']" multiple="' . ($group->isMultiple() ? 'true' : 'false') . '" configuration="{ service : { apiParams : { search: { data: { filters: { group : { op: \'eq\', val: ' . $group->getId() . ' } } } } } } }" form="taskForm"></keyword-select>';
                                                        echo '</span>';
                                                    echo '</td>';
                                                }
                                            }
                                        ?>
                                        <td>{{task.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                        <td>{{task.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                        <td>
                                            <div class="btn-group btn-group-actions" ng-if="self.editedLine !== task">
                                                <?php if ($this->acl()->isAllowed('task:e:task:r')) : ?>
                                                    <a ng-if="task._rights.read" ng-click="self.editTask(task)" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                        <?= $this->icon('edit') ?>
                                                    </a>
                                                <?php endif; ?>

                                                <?php if ($this->acl()->isAllowed('task:e:task:d')) : ?>
                                                    <a ng-if="task._rights.delete" ng-click="self.deleteTask(task)" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
                                                        <?= $this->icon('delete') ?>
                                                    </a>
                                                <?php endif; ?>
                                            </div>
                                            <div class="btn-group btn-group-actions" ng-if="self.editedLine == task">
                                                <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(task)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                    <?= $this->icon('save') ?>
                                                </button>
                                                <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                    <?= $this->icon('close') ?>
                                                </button>
                                            </div>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </form>
                    </div>
                </div>
            </table-builder>
        </div>
    </div>
    <?= $this->partial('task/index/form.phtml', ['from' => $this->from, 'object' => $this->object]) ?>
</div>


